<?php
/**
 *------------------------------------------------------------------------------
 *  iCagenda v3 by Jooml!C - Events Management Extension for Joomla! 2.5 / 3.x
 *------------------------------------------------------------------------------
 * @package     com_icagenda
 * @copyright   Copyright (c)2012-2013 Cyril Rezé, Jooml!C - All rights reserved
 *
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Cyril Rezé (Lyr!C)
 * @link        http://www.joomlic.com
 *
 * @version     3.1.2 2013-08-04
 * @since       1.0
 *------------------------------------------------------------------------------
*/

// No direct access to this file
defined('_JEXEC') or die();

JHtml::_('behavior.modal');
JHtml::_('behavior.multiselect');

$user	= JFactory::getUser();
$userId	= $user->get('id');
$listOrder	= $this->state->get('list.ordering');
$listDirn	= $this->state->get('list.direction');
$canOrder	= $user->authorise('core.edit.state', 'com_icagenda');
$saveOrder	= $listOrder == 'a.ordering';

if(version_compare(JVERSION, '3.0', 'lt')) {

	JHtml::_('behavior.tooltip');
	//JHtml::_('script','system/multiselect.js',false,true);

} else {

	// Include the component HTML helpers.
	JHtml::addIncludePath(JPATH_COMPONENT . '/helpers/html');
	JHtml::_('bootstrap.tooltip');
	JHtml::_('formbehavior.chosen', 'select');
	JHtml::_('dropdown.init');

	$archived	= $this->state->get('filter.published') == 2 ? true : false;
	$trashed	= $this->state->get('filter.published') == -2 ? true : false;

	if ($saveOrder)
	{
	    $saveOrderingUrl = 'index.php?option=com_icagenda&task=events.saveOrderAjax&tmpl=component';
	    JHtml::_('sortablelist.sortable', 'eventsList', 'adminForm', strtolower($listDirn), $saveOrderingUrl);
	}

}

include_once JPATH_ROOT.'/media/com_icagenda/scripts/icthumb.php';


?>

<form action="<?php echo JRoute::_('index.php?option=com_icagenda&view=events'); ?>" method="post" name="adminForm" id="adminForm">
<?php if (!empty( $this->sidebar)) : ?>
	<div id="j-sidebar-container" class="span2">
		<?php echo $this->sidebar; ?>
	</div>
	<div id="j-main-container" class="span10">
<?php else : ?>
	<div id="j-main-container">
<?php endif;?>

	<?php if(version_compare(JVERSION, '3.0', 'lt')) : ?>
		<fieldset id="filter-bar">
			<div class="filter-search fltlft">
				<label class="filter-search-lbl" for="filter_search"><?php echo JText::_('JSEARCH_FILTER_LABEL'); ?></label>
				<input type="text" name="filter_search" id="filter_search" value="<?php echo $this->escape($this->state->get('filter.search')); ?>" title="<?php echo JText::_('Search'); ?>" />
				<button type="submit"><?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?></button>
				<button type="button" onclick="document.id('filter_search').value='';this.form.submit();"><?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?></button>
			</div>
			<div class="filter-select fltrt">
				<select name="filter_published" class="inputbox" onchange="this.form.submit()">
					<option value=""><?php echo JText::_('JOPTION_SELECT_PUBLISHED');?></option>
					<?php echo JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), "value", "text", $this->state->get('filter.state'), true);?>
				</select>

				<!--select name="filter_access" class="inputbox" onchange="this.form.submit()">
					<option value=""><?php echo JText::_('JOPTION_SELECT_ACCESS');?></option>
					<?php echo JHtml::_('select.options', JHtml::_('access.assetgroups'), 'value', 'text', $this->state->get('filter.access'));?>
				</select>

				<select name="filter_language" class="inputbox" onchange="this.form.submit()">
					<option value=""><?php echo JText::_('JOPTION_SELECT_LANGUAGE');?></option>
					<?php echo JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $this->state->get('filter.language'));?>
				</select-->

			</div>
		</fieldset>
		<div class="clr"> </div>

	<?php else : ?>

		<div id="filter-bar" class="btn-toolbar">
			<div class="filter-search btn-group pull-left">
				<label for="filter_search" class="element-invisible"><?php echo JText::_('COM_ICAGENDA_FILTER_SEARCH_EVENTS_DESC'); ?></label>
				<input type="text" name="filter_search" placeholder="<?php echo JText::_('COM_ICAGENDA_FILTER_SEARCH_EVENTS_DESC'); ?>" id="filter_search" value="<?php echo $this->escape($this->state->get('filter.search')); ?>" title="<?php echo JText::_('COM_ICAGENDA_FILTER_SEARCH_EVENTS_DESC'); ?>" />
			</div>
			<div class="btn-group pull-left hidden-phone">
				<button class="btn tip hasTooltip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
				<button class="btn tip hasTooltip" type="button" onclick="document.id('filter_search').value='';this.form.submit();" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>"><i class="icon-remove"></i></button>
			</div>
			<div class="btn-group pull-right hidden-phone">
				<label for="limit" class="element-invisible"><?php echo JText::_('JFIELD_PLG_SEARCH_SEARCHLIMIT_DESC'); ?></label>
				<?php echo $this->pagination->getLimitBox(); ?>
			</div>
			<!--div class="btn-group pull-right hidden-phone">
				<label for="directionTable" class="element-invisible"><?php echo JText::_('JFIELD_ORDERING_DESC'); ?></label>
				<select name="directionTable" id="directionTable" class="input-medium" onchange="Joomla.orderTable()">
					<option value=""><?php echo JText::_('JFIELD_ORDERING_DESC'); ?></option>
					<option value="asc" <?php if ($listDirn == 'asc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_ASCENDING'); ?></option>
					<option value="desc" <?php if ($listDirn == 'desc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_DESCENDING');  ?></option>
				</select>
			</div-->
			<!--div class="btn-group pull-right">
				<label for="sortTable" class="element-invisible"><?php echo JText::_('JGLOBAL_SORT_BY'); ?></label>
				<select name="sortTable" id="sortTable" class="input-medium" onchange="Joomla.orderTable()">
					<option value=""><?php echo JText::_('JGLOBAL_SORT_BY');?></option>
					<?php echo JHtml::_('select.options', $sortFields, 'value', 'text', $listOrder); ?>
				</select>
			</div-->
		</div>
		<div class="clearfix"> </div>

	<?php endif;?>



	<?php if(version_compare(JVERSION, '3.0', 'lt')) : ?>
		<table class="adminlist">
	<?php else : ?>
		<table class="table table-striped" id="eventsList">
	<?php endif; ?>

			<thead>
				<tr>
<!-- Ordering HEADER Joomla 3.x -->
					<?php if(version_compare(JVERSION, '3.0', 'ge')) : ?>
 					<th width="1%" class="nowrap center hidden-phone">
						<?php echo JHtml::_('grid.sort', '<i class="icon-menu-2"></i>', 'a.ordering', $listDirn, $listOrder, null, 'asc', 'JGRID_HEADING_ORDERING'); ?>
					</th>
					<?php endif; ?>

<!-- CheckBox HEADER -->
					<th width="1%" class="hidden-phone">
						<input type="checkbox" name="checkall-toggle" value="" title="<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
					</th>

<!-- Status HEADER -->
					<th width="1%" style="min-width:55px" class="nowrap center">
						<?php echo JHtml::_('grid.sort', 'JSTATUS', 'a.state', $listDirn, $listOrder); ?>
					</th>

<!-- Image HEADER -->
					<th width="130px" class="nowrap center hidden-phone">
						<?php echo JHtml::_('grid.sort', 'COM_ICAGENDA_EVENTS_IMAGE', 'a.image', $listDirn, $listOrder); ?>
					</th>

<!-- Title HEADER -->
					<th>
						<?php echo JHtml::_('grid.sort', 'COM_ICAGENDA_EVENTS_TITLE', 'a.title', $listDirn, $listOrder); ?>
					</th>


<!-- Image HEADER -->
					<th width="15%" class="nowrap hidden-phone">
						<?php echo JHtml::_('grid.sort',  'COM_ICAGENDA_EVENTS_NEXT', 'a.next', $listDirn, $listOrder); ?>
					</th>


<!-- Ordering HEADER Joomla 2.5 -->
				<?php if(version_compare(JVERSION, '3.0', 'lt')) : ?>
					<?php if (isset($this->items[0]->ordering)) { ?>
					<th width="10%">
						<?php echo JHtml::_('grid.sort',  'JGRID_HEADING_ORDERING', 'a.ordering', $listDirn, $listOrder); ?>
						<?php if ($canOrder && $saveOrder) :?>
							<?php echo JHtml::_('grid.order',  $this->items, 'filesave.png', 'events.saveorder'); ?>
						<?php endif; ?>
					</th>
                	<?php } ?>
				<?php endif; ?>



<!-- Access HEADER -->
				<th width="10%" class="nowrap hidden-phone">
					<?php echo JHtml::_('grid.sort', 'JGRID_HEADING_ACCESS', 'access', $listDirn, $listOrder); ?>
				</th>

<!-- Author HEADER -->
				<th width="10%" class="nowrap hidden-phone">
				<?php echo JHtml::_('grid.sort',  'JAUTHOR', 'a.username', $listDirn, $listOrder); ?>
				</th>

<!-- Language HEADER -->
				<th width="5%" class="nowrap hidden-phone">
					<?php echo JHtml::_('grid.sort', 'JGRID_HEADING_LANGUAGE', 'language', $listDirn, $listOrder); ?>
				</th>

<!-- ID HEADER -->
					<th width="1%" class="nowrap hidden-phone">
						<?php echo JHtml::_('grid.sort', 'JGRID_HEADING_ID', 'a.id', $listDirn, $listOrder); ?>
					</th>


			</tr>
		</thead>
		<tfoot>
			<tr>
				<td colspan="12">
					<?php echo $this->pagination->getListFooter(); ?>
				</td>
			</tr>
		</tfoot>
		<tbody valign="top">
		<?php foreach ($this->items as $i => $item) :
			$ordering	= ($listOrder == 'a.ordering');
			$canCreate	= $user->authorise('core.create',		'com_icagenda');
			$canEdit	= $user->authorise('core.edit',			'com_icagenda');
			$canCheckin	= $user->authorise('core.manage',		'com_icagenda');
			$canChange	= $user->authorise('core.edit.state',	'com_icagenda');
			$canEditOwn	= $user->authorise('core.edit.own',		'com_icagenda') && $item->created_by == $userId;

			// Get Access Names
			$db = JFactory::getDBO();
			$db->setQuery(
				'SELECT `title`' .
				' FROM `#__viewlevels`' .
				' WHERE `id` = '. (int) $item->access
			);
			$access_title=$db->loadObject()->title;


					//SET LOCALE
					$codeset = "UTF8";  // warning ! not UTF-8 with dash '-'
 					$lang = JFactory::getLanguage();
					$tag = $lang->getTag();
					$tag=str_replace('-', '_', $tag);
					$locale = $lang->getlocale() ;
					setlocale( LC_ALL, $tag.'.'.$codeset ) ;

					$todaydate = date('Y-m-d');
					$today =  strtotime($todaydate);
					$dateformat = "%d %B %Y %H:%M";

					$nextget = $item->next;
					$nextget=str_replace(' ', '-', $nextget);
					$nextget=str_replace(':', '-', $nextget);
					$ex_data=explode('-', $nextget);

					$dateform =  date ("Y-m-d", mktime (0,0,0,$ex_data['1'], $ex_data['2'], $ex_data['0']));
//					$datetime =  date ("H:i", mktime ($ex_data['3'],$ex_data['4'],0,0,0,0));

					$nextdate = strtotime($dateform);
//					$nexttime = strtotime($datetime);
//					$timeNext = strftime("%H %i",strtotime("$item->next"));


			?>
			<tr class="row<?php echo $i % 2; ?>" sortable-group-id="<?php echo $item->catid?>">

<!-- Ordering Joomla 3.x -->
	<?php if(version_compare(JVERSION, '3.0', 'ge')) : ?>
					<td class="order nowrap center hidden-phone">
					<?php if ($canChange) :
						$disableClassName = '';
						$disabledLabel	  = '';

						if (!$saveOrder) :
							$disabledLabel    = JText::_('JORDERINGDISABLED');
							$disableClassName = 'inactive tip-top';
						endif; ?>
						<span class="sortable-handler hasTooltip <?php echo $disableClassName; ?>" title="<?php echo $disabledLabel; ?>">
							<i class="icon-menu"></i>
						</span>
						<input type="text" style="display:none" name="order[]" size="5" value="<?php echo $item->ordering; ?>" class="width-20 text-area-order " />
					<?php else : ?>
						<span class="sortable-handler inactive" >
							<i class="icon-menu"></i>
						</span>
					<?php endif; ?>
					</td>
	<?php endif; ?>


 <!-- CheckBox Joomla -->
					<td class="center hidden-phone">
						<?php echo JHtml::_('grid.id', $i, $item->id); ?>
					</td>

 <!-- Status Joomla -->
               <?php if (isset($this->items[0]->state)) { ?>
					<td class="center">
					<?php
					// Control of dates if valid (EDIT SINCE VERSION 3.0)
//					if (($nextdate == '943916400') OR ($nextdate == '943920000')) {
					if ($item->next == '0000-00-00 00:00:00') {
					    //echo JHtml::_('jgrid.published', $item->state, $i, 'events.', '', 'cb');
					    echo '<br/><i class="icon-warning"></i><br/><span style="color:red;"><strong>' . JText::_('COM_ICAGENDA_NO_VALID_DATE') . '</strong></span>';
						if ($item->state == '1') {
							//$state = 0;
        					$db		= Jfactory::getDbo();
							$query	= $db->getQuery(true);
        					$query->clear();
							$query->update(' #__icagenda_events ');
							$query->set(' state = 0 ' );
							$query->where(' id = ' . (int) $item->id );
							$db->setQuery((string)$query);
							$db->query($query);
 						}

					}
					else {
					    echo JHtml::_('jgrid.published', $item->state, $i, 'events.', $canChange, 'cb');
					}
					 ?>
				    </td>
                <?php } ?>


<!-- Image Joomla -->
						<td class="small hidden-phone">
							<div style="background:#F4F4F4; padding:5px; width:120px; text-align:center; overflow:hidden;">
							<?php if ($item->image) : ?>
							<?php
								// Get image file name
//								$url = $item->image;
//								$decomposition = explode( '/' , $url );
//								// Dans n'importe quelle racine
//								$i = 0;
//								while ( isset($decomposition[$i]) )
//									$i++;
//								$i--;
//								$imgname = $decomposition[$i];
//								$fichier = explode( '.', $decomposition[$i] );
//								$imgtitle = $fichier[0];


								//$GblParams = JComponentHelper::getParams('com_icagenda');
								//$MaxWidth = $GblParams->get('Event_MaxWidth');
								//$MaxHeight = $GblParams->get('Event_MaxHeight');
								//$Quality = $GblParams->get('Event_Quality');


								// Get Image File Infos (minimum php 5.2)
								$path = pathinfo($item->image);
								$imgname = $path['basename'];			// Get file base name
								$imgdirname = $path['dirname'];		// Get image dirname
								$imgextension = strtolower($path['extension']);	// Get image extension
								$imgtitle = $path['filename'];			// Get image name

								$cleanFileName = cleanString($imgtitle) . '.' . $imgextension;
								$cleanTitle = cleanString($imgtitle);
								//echo $cleanFileName;

								$thumbsPath = '/images/icagenda/thumbs/';
								$thumbsCopy = '/images/icagenda/thumbs/copy/';

								$imageValue = $item->image;
								$imageLink = $item->image;

								// Call function and create image thumbnail for events list in admin

								// If Image JPG, JPEG, PNG or GIF
								if (($imgextension == "jpg") OR ($imgextension == "jpeg") OR ($imgextension == "png") OR ($imgextension == "gif")) {

									$thumbsys = 'images/icagenda/thumbs/system/w120h100q100_' . $cleanFileName;

									if (!file_exists(JPATH_ROOT . '/' . $thumbsys)) {
										if (filter_var($imageValue, FILTER_VALIDATE_URL)) {

							if (url_exists($imageValue)) {

											$testFile = JPATH_ROOT . $thumbsCopy . $cleanFileName;
											if (!file_exists($testFile)) {
												//Get the file
												$content = file_get_contents($imageValue);
												//Store in the filesystem.
												$fp = fopen(JPATH_ROOT . $thumbsCopy . $cleanFileName, "w");
												fwrite($fp, $content);
												fclose($fp);
											}

											$linkToImage = JPATH_ROOT . $thumbsCopy . $cleanFileName;
											$imageValue = 'images/icagenda/thumbs/copy/' . $cleanFileName;

							} else {
								$linkToImage = $imageValue;
							}

										} else {
											$linkToImage = JPATH_ROOT . '/' . $imageValue;
										}
										if ((url_exists($linkToImage)) OR (file_exists($linkToImage))) {
											createthumb($linkToImage, JPATH_ROOT . '/' . $thumbsys, 120, 100, 100);
										} else {
											echo '<i class="icon-warning"></i><br/><span style="color:red;"><strong>' . JText::_('COM_ICAGENDA_INVALID_PICTURE_LINK') . '</strong></span>';
										}
									}
								}

								// If Image BMP
								elseif ($imgextension == "bmp") {
									$imageLink = 'images/icagenda/thumbs/copy/' . $cleanTitle . '.jpg';

									$thumbsys = 'images/icagenda/thumbs/system/w120h100q100_' . $cleanTitle . '.jpg';
									if (!file_exists(JPATH_ROOT . '/' . $thumbsys)) {
										if (filter_var($imageValue, FILTER_VALIDATE_URL)) {

							if (url_exists($imageValue)) {

											$testFile = JPATH_ROOT . $thumbsCopy . $cleanTitle . '.jpg';
											if (!file_exists($testFile)) {
												//Get the file
												$content = file_get_contents($imageValue);
												//Store in the filesystem.
												$fp = fopen(JPATH_ROOT . $thumbsCopy . $cleanFileName, "w");
												fwrite($fp, $content);
												fclose($fp);
												$imageNewValue = JPATH_ROOT . $thumbsCopy . $cleanFileName;
												imagejpeg(ImageCreateFromBMP($imageNewValue), JPATH_ROOT . $thumbsCopy . $cleanTitle . '.jpg', 100);
												unlink($imageNewValue);
											}

							} else {
								$linkToImage = $imageValue;
							}

										} else {
											imagejpeg(imagecreatefrombmptest(JPATH_ROOT . '/' . $imageValue), JPATH_ROOT . $thumbsCopy . $cleanTitle . '.jpg', 100);
										}
										$imageValue = 'images/icagenda/thumbs/copy/' . $cleanTitle . '.jpg';
										$linkToImage = JPATH_ROOT . '/' . $imageValue;
										if ((url_exists($linkToImage)) OR (file_exists($linkToImage))) {
											createthumb($linkToImage, JPATH_ROOT . '/' . $thumbsys, 120, 100, 100);
										} else {
											echo '<i class="icon-warning"></i><br/><span style="color:red;"><strong>' . JText::_('COM_ICAGENDA_INVALID_PICTURE_LINK') . '</strong></span>';
										}
									}
								} else {
									echo '<i class="icon-warning"></i><br/><span style="color:red;"><strong>' . JText::_('COM_ICAGENDA_INVALID_PICTURE_LINK') . '</strong></span>';
								}


								//createthumb($linkToImage, JPATH_ROOT . $thumbsPath . 'w'.$MaxWidth.'h'.$MaxHeight.'q'.$Quality.'_' . $imgname, $MaxWidth, $MaxHeight, $Quality);

								if (filter_var($imageLink, FILTER_VALIDATE_URL)) {
								?>
									<a href="<?php echo $imageLink; ?>" class="modal">
								<?php
								} else {
								?>
									<a href="../<?php echo $imageLink; ?>" class="modal">
								<?php
								}
								?>
										<img src="../<?php echo $thumbsys; ?>" />
									</a>
							<?php else:?>
								<img style="max-width:120px; max-height:100px;" src="../media/com_icagenda/images/nophoto.jpg" />
							<?php endif; ?>
							</div>
						</td>
<!-- Title & Category -->
					<td class="nowrap has-context">
						<div class="pull-left">
							<?php if ($item->checked_out) : ?>
								<?php echo JHtml::_('jgrid.checkedout', $i, $item->editor, $item->checked_out_time, 'events.', $canCheckin); ?>
							<?php endif; ?>
							<?php if ($item->language == '*'):?>
								<?php $language = JText::alt('JALL', 'language'); ?>
							<?php else:?>
								<?php $language = $item->language ? $this->escape($item->language) : JText::_('JUNDEFINED'); ?>
							<?php endif;?>
							<?php if ($canEdit || $canEditOwn) : ?>
								<a href="<?php echo JRoute::_('index.php?option=com_icagenda&task=event.edit&id=' . $item->id); ?>" title="<?php echo JText::_('JACTION_EDIT'); ?>">
									<?php echo $this->escape($item->title); ?></a>
							<?php else : ?>
								<span title="<?php echo JText::sprintf('JFIELD_ALIAS_LABEL', $this->escape($item->alias)); ?>"><?php echo $this->escape($item->title); ?></span>
							<?php endif; ?>
							<div class="small">
								<?php echo JText::_('JCATEGORY') . ": " . $this->escape($item->category); ?>
							</div>
							<?php if (($item->place) OR ($item->city) OR ($item->country)) : ?>
							<!--div class="small" style="height:5px; border-bottom: solid 1px #D4D4D4">
							</div-->
							<p>
							<?php if ($item->place) : ?>
							<div class="small iC-italic-grey">
								<?php echo JText::_('COM_ICAGENDA_TITLE_LOCATION') . ": " . $this->escape($item->place); ?>
							</div>
							<?php endif; ?>
							<?php if ($item->city) : ?>
							<div class="small iC-italic-grey">
								<?php echo JText::_('COM_ICAGENDA_FORM_LBL_EVENT_CITY') . ": " . $this->escape($item->city); ?>
							</div>
							<?php endif; ?>
							<?php if ($item->country) : ?>
							<div class="small iC-italic-grey">
								<?php echo JText::_('COM_ICAGENDA_FORM_LBL_EVENT_COUNTRY') . ": " . $this->escape($item->country); ?>
							</div></p>
							<?php endif; ?>
							<?php endif; ?>
						</div>

	<!-- DropDown Edit Joomla 3 -->
	<?php if(version_compare(JVERSION, '3.0', 'ge')) : ?>
						<div class="pull-left">
							<?php
								// Create dropdown items
								JHtml::_('dropdown.edit', $item->id, 'event.');
								JHtml::_('dropdown.divider');
								if ($item->state) :
									JHtml::_('dropdown.unpublish', 'cb' . $i, 'events.');
								else :
									JHtml::_('dropdown.publish', 'cb' . $i, 'events.');
								endif;

//								if ($item->featured) :
//									JHtml::_('dropdown.unfeatured', 'cb' . $i, 'events.');
//								else :
//									JHtml::_('dropdown.featured', 'cb' . $i, 'events.');
//								endif;

								JHtml::_('dropdown.divider');

								if ($archived) :
									JHtml::_('dropdown.unarchive', 'cb' . $i, 'events.');
								else :
									JHtml::_('dropdown.archive', 'cb' . $i, 'events.');
								endif;

								if ($item->checked_out) :
									JHtml::_('dropdown.checkin', 'cb' . $i, 'events.');
								endif;

								if ($trashed) :
									JHtml::_('dropdown.untrash', 'cb' . $i, 'events.');
								else :
									JHtml::_('dropdown.trash', 'cb' . $i, 'events.');
								endif;

								// Render dropdown list
								echo JHtml::_('dropdown.render');
								?>
						</div>
	<?php endif; ?>

					</td>

<!-- Dates -->
				<td class="small hidden-phone">
					<?php

					if (!$item->time == NULL) {
						$dateshow = strftime("%d %B %Y",strtotime("$item->next"));
//						$eventtime = '<small>(' . $item->time . ')</small>';
					}
					if ($item->time == NULL) {
						$dateshow = strftime($dateformat,strtotime("$item->next"));
//						$eventtime = ' ';
					}

					if ($nextdate > $today) {
						echo '<div style="font-weight:bold; background:#555; color:#FFFFFF; padding: 2px 5px; border-radius: 3px;">'.JText::_( 'COM_ICAGENDA_EVENTS_NEXT_FUTUR' ).'<br /><center>';
					 	echo $dateshow . '</center></div>';
					 }
					if ($nextdate == $today) {
						echo '<div style="font-weight:bold; background:#c30000; color:#FFFFFF; padding: 2px 5px; border-radius: 5px;">'.JText::_( 'COM_ICAGENDA_EVENTS_NEXT_TODAY' ).'<br /><center>';
					 	echo $dateshow . '</center></div>';
					}
					// (EDIT SINCE VERSION 3.0)
					if (($nextdate < $today) && ($item->next != '0000-00-00 00:00:00')) {
						echo '<div style="font-style:italic; background:#E4E4E4; color:#777; padding: 2px 5px; border-radius: 5px;">'.JText::_( 'COM_ICAGENDA_EVENTS_NEXT_PAST' ).'<br /><center>';
					 	echo $dateshow . '</center></div>';
					}
					// Control of dates if valid (EDIT SINCE VERSION 3.0)
					if ($item->next == '0000-00-00 00:00:00'){
						echo '<div style="font-style:italic; background:#E4E4E4; color:#777; padding: 2px 5px; border-radius: 5px;">'.JText::_( 'COM_ICAGENDA_EVENTS_NEXT_ALERT' ).'';
					 	echo '</div>';
					}
					?>
				</td>


<!-- Ordering Joomla 2.5 -->
	<?php if(version_compare(JVERSION, '3.0', 'lt')) : ?>
                <?php if (isset($this->items[0]->ordering)) { ?>
				    <td class="order">
					    <?php if ($canChange) : ?>
						    <?php if ($saveOrder) :?>
							    <?php if ($listDirn == 'asc') : ?>
								    <span><?php echo $this->pagination->orderUpIcon($i, true, 'events.orderup', 'JLIB_HTML_MOVE_UP', $ordering); ?></span>
								    <span><?php echo $this->pagination->orderDownIcon($i, $this->pagination->total, true, 'events.orderdown', 'JLIB_HTML_MOVE_DOWN', $ordering); ?></span>
							    <?php elseif ($listDirn == 'desc') : ?>
								    <span><?php echo $this->pagination->orderUpIcon($i, true, 'events.orderdown', 'JLIB_HTML_MOVE_UP', $ordering); ?></span>
								    <span><?php echo $this->pagination->orderDownIcon($i, $this->pagination->total, true, 'events.orderup', 'JLIB_HTML_MOVE_DOWN', $ordering); ?></span>
							    <?php endif; ?>
						    <?php endif; ?>
						    <?php $disabled = $saveOrder ?  '' : 'disabled="disabled"'; ?>
						    <input type="text" name="order[]" size="5" value="<?php echo $item->ordering;?>" <?php echo $disabled ?> class="text-area-order" />
					    <?php else : ?>
						    <?php echo $item->ordering; ?>
					    <?php endif; ?>
				    </td>
                <?php } ?>
	<?php endif; ?>

<!-- Access -->
					<td class="small hidden-phone">
					<?php echo $this->escape($access_title); ?>
				</td>

<!-- Username -->
					<td class="small hidden-phone">
					<?php
					$user = JFactory::getUser();
					$userId	= $user->get('id');

					$name=$user->get('name');
					$username=$user->get('username');
					$usernone=$item->username;

					if ($usernone=='') {
						$undefined = '<i>'.JText::_('JUNDEFINED').'</i>';
						echo $undefined;
					} else {
						echo $this->escape($item->username);
					}
					?>
					<?php //echo JText::_('JGLOBAL_USERNAME').': '.$this->escape($username); ?>
					<?php echo ' ['.$this->escape($username).']'; ?>
						<?php if ($item->created_by_alias) : ?>
					<p class="smallsub">
							<?php echo JText::sprintf('JGLOBAL_LIST_ALIAS', $this->escape($item->created_by_alias)); ?>
					</p>
						<?php endif; ?>
					</td>

<!-- Language -->
					<td class="small hidden-phone">
						<?php if ($item->language == '*'):?>
							<?php echo JText::alt('JALL', 'language'); ?>
						<?php else:?>
							<?php echo $item->language ? $this->escape($item->language) : JText::_('JUNDEFINED'); ?>
						<?php endif;?>
					</td>

<!-- ID -->
                	<?php if (isset($this->items[0]->id)) { ?>
					<td class="center hidden-phone">
						<?php echo (int) $item->id; ?>
					</td>
                	<?php } ?>

			</tr>
			<?php endforeach; ?>
		</tbody>
	</table>

	<div>
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
		<?php echo JHtml::_('form.token'); ?>
	</div>
</div>
</form>
